
/***************************************************************************/
/* Recursive program to walk down the given tree of an XML document loaded */
/* into DOM.  (See DOMParse.p.)                                            */
/* It's puprose is to count the number of occurences of a tag in the XML   */
/* like a length() computation in Javascript.                              */
/***************************************************************************/
DEFINE VARIABLE RCS AS CHARACTER
 INIT "$Header: /appl/DOM/src/RCS/DOMFindTag.p,v 1.1 2007/03/17 14:50:08 sauge Exp sauge $".

DEFINE INPUT-OUTPUT PARAMETER hNode AS HANDLE NO-UNDO.
DEFINE INPUT PARAMETER cTagName AS CHARACTER NO-UNDO.
DEFINE INPUT-OUTPUT PARAMETER iCountOfTagName AS INTEGER NO-UNDO.
DEFINE INPUT PARAMETER iDesiredOccurance AS INTEGER NO-UNDO.
DEFINE OUTPUT PARAMETER cData AS CHARACTER NO-UNDO.
                                                  
DEFINE VARIABLE iCurNode AS INTEGER NO-UNDO.
DEFINE VARIABLE hWorkingNode AS HANDLE NO-UNDO.
DEFINE VARIABLE hText AS HANDLE NO-UNDO.

DO iCurNode = 1 TO hNode:NUM-CHILDREN :
  
  CREATE X-NODEREF hWorkingNode.
  hNode:GET-CHILD(hWorkingNode, iCurNode) NO-ERROR. 

  IF VALID-HANDLE (hWorkingNode) THEN DO: 
              
    IF hWorkingNode:NAME = cTagName THEN DO:
      
      ASSIGN iCountOfTagName = iCountOfTagName + 1.                            
    
      IF iCountOfTagName = iDesiredOccurance THEN DO:
      
        /******************************************/
        /* The text of a node is actually a child */
        /* So we prep up a node ref on the fly    */
        /* and use it to get to the right         */
        /* node-value.                            */       
        /******************************************/
        
        IF hWorkingNode:NUM-CHILDREN > 0 THEN DO:
          
          CREATE X-NODEREF hText.
          
          hWorkingNode:GET-CHILD (hText, 1) NO-ERROR.
          
          IF VALID-HANDLE (hText) THEN
            ASSIGN cData = hText:NODE-VALUE NO-ERROR.
          ELSE
            ASSIGN cData = ?.
          
          DELETE OBJECT hWorkingNode.
          DELETE OBJECT hText.
          
          RETURN.
          
        END.
      
      END. /* Found our desired node */
      
    END. /* Examining a node of interest */
      
    RUN DOMFindTag.p (INPUT-OUTPUT hWorkingNode, 
                      INPUT cTagName, 
                      INPUT-OUTPUT iCountOfTagName, 
                      INPUT iDesiredOccurance,
                      OUTPUT cData).
    
    DELETE OBJECT hWorkingNode.
    
    IF iCountOftagName = iDesiredOccurance THEN RETURN.
    
  END. /* IF VALID-HANDLE */
  
END. /* FOR EACH iCurNode */
