
/***************************************************************************/
/* Recursive program to walk down the given tree of an XML document loaded */
/* into DOM.  (See DOMParse.p.)                                            */
/* It's purpose is to find the n'th iteration of a given tag name and list */
/* the available attributes on that tag.                                   */
/***************************************************************************/
DEFINE VARIABLE RCS AS CHARACTER
 INIT "$Header: /appl/DOM/src/RCS/DOMListAttrs.p,v 1.1 2007/03/17 14:50:43 sauge Exp sauge $".

DEFINE INPUT-OUTPUT PARAMETER hNode AS HANDLE NO-UNDO.
DEFINE INPUT PARAMETER cTagName AS CHARACTER NO-UNDO.
DEFINE INPUT-OUTPUT PARAMETER iCountOfTagName AS INTEGER NO-UNDO.
DEFINE INPUT PARAMETER iDesiredOccurance AS INTEGER NO-UNDO.
DEFINE OUTPUT PARAMETER cData AS CHARACTER NO-UNDO.

DEFINE VARIABLE iCurNode AS INTEGER NO-UNDO.
DEFINE VARIABLE hWorkingNode AS HANDLE NO-UNDO.

DO iCurNode = 1 TO hNode:NUM-CHILDREN :

  CREATE X-NODEREF hWorkingNode.
  hNode:GET-CHILD(hWorkingNode, iCurNode).

  IF hWorkingNode:NAME = cTagName THEN DO:

    ASSIGN iCountOfTagName = iCountOfTagName + 1.

    IF iCountOfTagName = iDesiredOccurance THEN DO:

      ASSIGN cData = hWorkingNode:ATTRIBUTE-NAMES.

      DELETE OBJECT hWorkingNode.

      RETURN.

    END. /* Found our desired node */

  END. /* Examining a node of interest */

  RUN DOMListAttrs.p (INPUT-OUTPUT hWorkingNode,
                     INPUT cTagName,
                     INPUT-OUTPUT iCountOfTagName,
                     INPUT iDesiredOccurance,
                     OUTPUT cData).

  DELETE OBJECT hWorkingNode.

  IF iCountOftagName = iDesiredOccurance THEN RETURN.

END. /* FOR EACH iCurNode */
